unit hiIconEx;

interface

uses Windows,Kol,Share,Debug;

type
  ThiIconEx = class(TDebug)
   private
    Icon:PIcon;
    procedure SetIcon(value:HICON);
   public
    _prop_Transparent:TColor;
    _data_FileName:THI_Event;
    _event_onBitmap:THI_Event;

    destructor Destroy; override;
    procedure _work_doLoad(var _Data:TData; Index:word);
    procedure _work_doSave(var _Data:TData; Index:word);
    procedure _work_doBitmap(var _Data:TData; Index:word);
    procedure _work_doLoadFromBitmap(var _Data:TData; Index:word);
    procedure _var_Icon(var _Data:TData; Index:word);
    property _prop_Icon:HICON write SetIcon;
  end;

implementation

destructor ThiIconEx.Destroy;
begin
   if Assigned(Icon) then free_and_nil(Icon);
   inherited;
end;

procedure ThiIconEx._work_doLoad;
var fn:string;
begin
   if Assigned(Icon) then free_and_nil(Icon);
   Icon := NewIcon;
   fn := ReadFileName(ReadString(_Data,_data_FileName,''));
   Icon.LoadFromFile(fn);
end;

procedure ThiIconEx._work_doSave;
begin
   if Assigned(Icon) then
      Icon.SaveToFile(ReadString(_Data,_data_FileName,''));
end;

procedure ThiIconEx._work_doBitmap;
var bmp:PBitmap;
begin
   if (_Data.Data_type <> data_Icon) and (not Assigned(Icon)) then exit
   else if (_Data.Data_type = data_Icon) then
      begin
         if Assigned(Icon) then free_and_nil(Icon);
         Icon := NewIcon;
         Icon.Handle:= PIcon(_data.idata).handle
      end;
   bmp := NewBitmap(0,0);
   bmp.Handle:= Icon.Convert2Bitmap(_prop_Transparent);
   dtBitmap(_Data,bmp);
   _hi_OnEvent(_event_onBitmap,_Data);
   bmp.Free;
end;

procedure ThiIconEx._work_doLoadFromBitmap;
var bmp,mask,body:PBitmap;
    i,j:integer;
    II: TIconInfo;
begin
   bmp := ToBitmap(_Data);
   if bmp <> nil then
     begin
       body := NewBitmap(bmp.Width,bmp.Height);
       Body.Assign(bmp);
       Mask := NewBitmap(bmp.Width,bmp.Height);
       Mask.Assign(bmp);
       Mask.Convert2Mask(_prop_Transparent);

       for i := 0 to bmp.Width-1 do
        for j := 0 to bmp.Height-1 do
         if Body.Canvas.Pixels[i,j] = _prop_Transparent then
           Body.Canvas.Pixels[i,j] := clBlack;

       if Assigned(Icon) then free_and_nil(Icon);
       Icon := NewIcon;
       II.fIcon := true;
       II.xHotspot := 0;
       II.yHotspot := 0;
       II.hbmMask := Mask.Handle;
       II.hbmColor := Body.Handle;
       Icon.Handle := CreateIconIndirect(II);
       free_and_nil(Mask);
       free_and_nil(Body);
     end;
end;

procedure ThiIconEx._var_Icon;
begin
   if Assigned(Icon) then
      dtIcon(_Data,Icon)
   else dtNull(_Data);
end;

procedure ThiIconEx.SetIcon;
begin
   Icon:= NewIcon;
   Icon.Handle:= Value;
end;

end.
